<!----------------------------------------------------------------------------------------------------------------------
  -- Main Page
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="main-page" class="container page">
        <div class="mt-4 p-5 bg-secondary-subtle text-white-subtle rounded">
            <h1>Strata Service Tools</h1>
            <h5 class="text-muted">
                A UI for calling Strata Services.
            </h5>

            <!-- Spacer -->
            <div class="my-3" />

            <div v-if="authEnabled" class="text-muted">
                <div>Please log in to continue</div>
                <BButton variant="primary" href="/auth/gitlab">
                    <Fa :icon="[ 'fab', 'gitlab' ]" />
                    GitLab Login
                </BButton>
            </div>
            <BButton v-else variant="primary" to="/requests">
                Make Requests
                <Fa icon="arrow-right" />
            </BButton>
        </div>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { watch } from 'vue';
    import { useRouter } from 'vue-router';

    import { useObservable } from '../lib/composables/rxjs.js';

    // Managers
    import authMan from '../lib/managers/auth.js';

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const router = useRouter();

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const authInitialized = useObservable(authMan.initialized$);
    const authEnabled = useObservable(authMan.authEnabled$);
    const account = useObservable(authMan.account$);

    //------------------------------------------------------------------------------------------------------------------
    // Watches
    //------------------------------------------------------------------------------------------------------------------

    // When auth initializes, if auth is disabled, redirect to the requests page
    watch(authInitialized, (initialized) =>
    {
        if(initialized)
        {
            if(!authEnabled.value)
            {
                router.push('/requests');
            }
        }
    }, { immediate: true });

    // When/if the account is set, redirect to the requests page
    watch(account, (newAccount) =>
    {
        if(newAccount)
        {
            router.push('/requests');
        }
    }, { immediate: true });
</script>

<!--------------------------------------------------------------------------------------------------------------------->
